package org.apache.catalina;
import java.util.Iterator;
import javax.servlet.http.HttpSession;
import java.security.Principal;
public interface Session {
    public static final String SESSION_CREATED_EVENT = "createSession";
    public static final String SESSION_DESTROYED_EVENT = "destroySession";
    public static final String SESSION_ACTIVATED_EVENT = "activateSession";
    public static final String SESSION_PASSIVATED_EVENT = "passivateSession";
    String getAuthType();
    void setAuthType ( String p0 );
    long getCreationTime();
    long getCreationTimeInternal();
    void setCreationTime ( long p0 );
    String getId();
    String getIdInternal();
    void setId ( String p0 );
    void setId ( String p0, boolean p1 );
    long getThisAccessedTime();
    long getThisAccessedTimeInternal();
    long getLastAccessedTime();
    long getLastAccessedTimeInternal();
    long getIdleTime();
    long getIdleTimeInternal();
    Manager getManager();
    void setManager ( Manager p0 );
    int getMaxInactiveInterval();
    void setMaxInactiveInterval ( int p0 );
    void setNew ( boolean p0 );
    Principal getPrincipal();
    void setPrincipal ( Principal p0 );
    HttpSession getSession();
    void setValid ( boolean p0 );
    boolean isValid();
    void access();
    void addSessionListener ( SessionListener p0 );
    void endAccess();
    void expire();
    Object getNote ( String p0 );
    Iterator<String> getNoteNames();
    void recycle();
    void removeNote ( String p0 );
    void removeSessionListener ( SessionListener p0 );
    void setNote ( String p0, Object p1 );
    void tellChangedSessionId ( String p0, String p1, boolean p2, boolean p3 );
    boolean isAttributeDistributable ( String p0, Object p1 );
}
